/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Types.h"
#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Parameters.h"
#include <sstream>

namespace morpheo                    {
namespace behavioural {
namespace core {
namespace multi_execute_loop {
namespace execute_loop {
namespace multi_execute_unit {
namespace execute_unit {
namespace functionnal_unit {


#undef  FUNCTION
#define FUNCTION "Functionnal_unit::msg_error"
  std::string Parameters::msg_error(void)
  {
    log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");

    std::string msg = "";

    for (uint32_t i=0; i<MAX_OPERATION; i++)
      if (_timing->_delay != _timing->_latence)
	msg = "  - For the operation '"+toString(i)+"', the delay and the latence must be equal.";

    if (_have_groupe_MAC and ((_timing[OPERATION_ALU_L_MAC  ]._latence == 0) or
			      (_timing[OPERATION_ALU_L_MACRC]._latence == 0) or
			      (_timing[OPERATION_ALU_L_MSB  ]._latence == 0)))
      msg = "  - The functionnal unit implement a MAC unit, the latence to operation OPERATION_ALU_L_MAC, OPERATION_ALU_L_MACRC and OPERATION_ALU_L_MSB must be higher than 0.";

    return msg;

    log_printf(FUNC,Functionnal_unit,FUNCTION,"End");
  };

}; // end namespace functionnal_unit
}; // end namespace execute_unit
}; // end namespace multi_execute_unit
}; // end namespace execute_loop
}; // end namespace multi_execute_loop
}; // end namespace core
}; // end namespace behavioural
}; // end namespace morpheo              
